]> git.ipfire.org Git - thirdparty/git.git/blame - git-repack.sh
Git 1.8.1-rc1
[thirdparty/git.git] / git-repack.sh
CommitLineData
b2d46199 1#!/bin/sh
ccf1ee32
JH
2#
3# Copyright (c) 2005 Linus Torvalds
4#
5
5715d0bb
PH
6OPTIONS_KEEPDASHDASH=
7OPTIONS_SPEC="\
1b1dd23f 8git repack [options]
5715d0bb
PH
9--
10a pack everything in a single pack
ca11b212 11A same as -a, and turn unreachable objects loose
5715d0bb 12d remove redundant packs, and run git-prune-packed
5c47e1c7
JK
13f pass --no-reuse-delta to git-pack-objects
14F pass --no-reuse-object to git-pack-objects
2b36b146 15n do not run git-update-server-info
5715d0bb
PH
16q,quiet be quiet
17l pass --local to git-pack-objects
7e52f566 18unpack-unreachable= with -A, do not loosen objects older than this
5715d0bb
PH
19 Packing constraints
20window= size of the window used for delta compression
21window-memory= same as the above, but limit memory size instead of entries count
22depth= limits the maximum delta depth
23max-pack-size= maximum size of each packfile
24"
d0b353b1 25SUBDIRECTORY_OK='Yes'
ae2b0f15 26. git-sh-setup
ccb36504 27
ca11b212 28no_update_info= all_into_one= remove_redundant= unpack_unreachable=
2e6a30ef 29local= no_reuse= extra=
822f7c73 30while test $# != 0
ccf1ee32
JH
31do
32 case "$1" in
33 -n) no_update_info=t ;;
d5acdcf1 34 -a) all_into_one=t ;;
65aa5302 35 -A) all_into_one=t
ca11b212 36 unpack_unreachable=--unpack-unreachable ;;
7e52f566
JK
37 --unpack-unreachable)
38 unpack_unreachable="--unpack-unreachable=$2"; shift ;;
0adb3358 39 -d) remove_redundant=t ;;
2e6a30ef 40 -q) GIT_QUIET=t ;;
5c47e1c7
JK
41 -f) no_reuse=--no-reuse-delta ;;
42 -F) no_reuse=--no-reuse-object ;;
cec2be76 43 -l) local=--local ;;
5715d0bb
PH
44 --max-pack-size|--window|--window-memory|--depth)
45 extra="$extra $1=$2"; shift ;;
46 --) shift; break;;
9678faaa 47 *) usage ;;
ccf1ee32
JH
48 esac
49 shift
50done
51
22c79eab 52case "`git config --bool repack.usedeltabaseoffset || echo true`" in
b6945f57
JH
53true)
54 extra="$extra --delta-base-offset" ;;
55esac
56
d5acdcf1 57PACKDIR="$GIT_OBJECT_DIRECTORY/pack"
e32dfec7 58PACKTMP="$PACKDIR/.tmp-$$-pack"
0ea2582d
ML
59rm -f "$PACKTMP"-*
60trap 'rm -f "$PACKTMP"-*' 0 1 2 3 15
d5acdcf1
JH
61
62# There will be more repacking strategies to come...
63case ",$all_into_one," in
64,,)
cd0d74d2 65 args='--unpacked --incremental'
d5acdcf1
JH
66 ;;
67,t,)
2478dc84 68 args= existing=
ce859074
SP
69 if [ -d "$PACKDIR" ]; then
70 for e in `cd "$PACKDIR" && find . -type f -name '*.pack' \
71 | sed -e 's/^\.\///' -e 's/\.pack$//'`
72 do
73 if [ -e "$PACKDIR/$e.keep" ]; then
74 : keep
75 else
ce859074
SP
76 existing="$existing $e"
77 fi
78 done
171110a4 79 if test -n "$existing" -a -n "$unpack_unreachable" -a \
83d0289d 80 -n "$remove_redundant"
f7991d1e 81 then
7e52f566
JK
82 # This may have arbitrary user arguments, so we
83 # have to protect it against whitespace splitting
84 # when it gets run as "pack-objects $args" later.
85 # Fortunately, we know it's an approxidate, so we
86 # can just use dots instead.
87 args="$args $(echo "$unpack_unreachable" | tr ' ' .)"
f7991d1e 88 fi
65aa5302 89 fi
d5acdcf1
JH
90 ;;
91esac
0ea2582d 92
e32dfec7
TR
93mkdir -p "$PACKDIR" || exit
94
2e6a30ef 95args="$args $local ${GIT_QUIET:+-q} $no_reuse$extra"
7f3140cd 96names=$(git pack-objects --keep-true-parents --honor-pack-keep --non-empty --all --reflog $args </dev/null "$PACKTMP") ||
b2d46199 97 exit 1
6b94b1a0 98if [ -z "$names" ]; then
2e6a30ef 99 say Nothing new to pack.
6b94b1a0 100fi
d5acdcf1 101
3e6b1d0a 102# Ok we have prepared all new packfiles.
3e6b1d0a
JH
103
104# First see if there are packs of the same name and if so
105# if we can move them out of the way (this can happen if we
106# repacked immediately after packing fully.
107rollback=
108failed=
109for name in $names
110do
2ad47d61
JH
111 for sfx in pack idx
112 do
3e6b1d0a
JH
113 file=pack-$name.$sfx
114 test -f "$PACKDIR/$file" || continue
115 rm -f "$PACKDIR/old-$file" &&
116 mv "$PACKDIR/$file" "$PACKDIR/old-$file" || {
117 failed=t
118 break
119 }
120 rollback="$rollback $file"
121 done
122 test -z "$failed" || break
123done
124
125# If renaming failed for any of them, roll the ones we have
126# already renamed back to their original names.
127if test -n "$failed"
128then
129 rollback_failure=
130 for file in $rollback
131 do
132 mv "$PACKDIR/old-$file" "$PACKDIR/$file" ||
133 rollback_failure="$rollback_failure $file"
134 done
135 if test -n "$rollback_failure"
136 then
137 echo >&2 "WARNING: Some packs in use have been renamed by"
138 echo >&2 "WARNING: prefixing old- to their name, in order to"
139 echo >&2 "WARNING: replace them with the new version of the"
140 echo >&2 "WARNING: file. But the operation failed, and"
141 echo >&2 "WARNING: attempt to rename them back to their"
142 echo >&2 "WARNING: original names also failed."
143 echo >&2 "WARNING: Please rename them in $PACKDIR manually:"
144 for file in $rollback_failure
145 do
146 echo >&2 "WARNING: old-$file -> $file"
147 done
148 fi
149 exit 1
150fi
151
152# Now the ones with the same name are out of the way...
153fullbases=
154for name in $names
155do
156 fullbases="$fullbases pack-$name"
157 chmod a-w "$PACKTMP-$name.pack"
158 chmod a-w "$PACKTMP-$name.idx"
0ea2582d 159 mv -f "$PACKTMP-$name.pack" "$PACKDIR/pack-$name.pack" &&
3e6b1d0a
JH
160 mv -f "$PACKTMP-$name.idx" "$PACKDIR/pack-$name.idx" ||
161 exit
162done
163
164# Remove the "old-" files
165for name in $names
166do
167 rm -f "$PACKDIR/old-pack-$name.idx"
168 rm -f "$PACKDIR/old-pack-$name.pack"
6b94b1a0 169done
d5acdcf1 170
3e6b1d0a
JH
171# End of pack replacement.
172
0adb3358 173if test "$remove_redundant" = t
d5acdcf1 174then
ce859074
SP
175 # We know $existing are all redundant.
176 if [ -n "$existing" ]
62af0b53 177 then
6ed64058
JH
178 ( cd "$PACKDIR" &&
179 for e in $existing
180 do
dca3957b
DH
181 case " $fullbases " in
182 *" $e "*) ;;
ce859074 183 *) rm -f "$e.pack" "$e.idx" "$e.keep" ;;
62af0b53 184 esac
6ed64058
JH
185 done
186 )
d5acdcf1 187 fi
2e6a30ef 188 git prune-packed ${GIT_QUIET:+-q}
d5acdcf1 189fi
ccf1ee32 190
ccf1ee32
JH
191case "$no_update_info" in
192t) : ;;
e1dc49bc 193*) git update-server-info ;;
ccf1ee32 194esac